Attribute VB_Name = "Module3"

Public Type point
    xc As Single
    yc As Single
End Type


Public Function cplxAdd(z1 As point, z2 As point) As point
    cplxAdd.xc = z1.xc + z2.xc
    cplxAdd.yc = z1.yc + z2.yc
End Function


Public Function cplxSub(z1 As point, z2 As point) As point
    cplxSub.xc = z1.xc - z2.xc
    cplxSub.yc = z1.yc - z2.yc
End Function


Public Function cplxMult(z1 As point, z2 As point) As point
    cplxMult.xc = z1.xc * z2.xc - z1.yc * z2.yc
    cplxMult.yc = z1.xc * z2.yc + z1.yc * z2.xc
End Function


Public Function cplxDiv(z1 As point, z2 As point) As point
    Dim magSq As Single
    magSq = z2.xc * z2.xc + z2.yc * z2.yc
    cplxDiv.xc = (z1.xc * z2.xc + z1.yc * z2.yc) / magSq
    cplxDiv.yc = (z1.yc * z2.xc - z1.xc * z2.yc) / magSq
End Function


Public Function cplxSqrt(z As point, root1 As point, root2 As point) As Integer
    Dim magZ As Single, argZ As Single
    Dim magRoot As Single, argRoot1 As Single, argRoot2 As Single
    magZ = Sqr(z.xc * z.xc + z.yc * z.yc)
    magRoot = Sqr(magZ)
    
    If Not z.xc = 0 Then
        argZ = Atn(z.yc / z.xc)
    Else
        argZ = pi / 2
    End If
    If z.yc < 0 And z.xc <= 0 Then
        argZ = argZ - pi
    ElseIf z.yc >= 0 And z.xc < 0 Then
        argZ = argZ + pi
    End If
    
    argRoot1 = argZ / 2
    If argZ <= 0 Then
        argRoot2 = argRoot1 + pi
    Else
        argRoot2 = argRoot1 - pi
    End If
    
    root1.xc = magRoot * Cos(argRoot1)
    root1.yc = magRoot * Sin(argRoot1)
    root2.xc = magRoot * Cos(argRoot2)
    root2.yc = magRoot * Sin(argRoot2)
End Function

