VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5640
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9240
   LinkTopic       =   "Form1"
   ScaleHeight     =   1
   ScaleLeft       =   -1
   ScaleMode       =   0  'User
   ScaleTop        =   -1
   ScaleWidth      =   1.213
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton set2 
      Caption         =   "Draw Set fast"
      Height          =   375
      Left            =   5640
      TabIndex        =   17
      Top             =   2760
      Width           =   1695
   End
   Begin VB.CommandButton clrpln 
      Caption         =   "Clear"
      Height          =   375
      Left            =   8040
      TabIndex        =   16
      Top             =   3360
      Width           =   975
   End
   Begin VB.CommandButton julia2 
      Caption         =   "Fast Julia"
      Height          =   315
      Left            =   6000
      TabIndex        =   15
      Top             =   3960
      Width           =   1575
   End
   Begin VB.TextBox divrad 
      Height          =   285
      Left            =   7335
      TabIndex        =   14
      Top             =   4680
      Width           =   780
   End
   Begin VB.TextBox cnverr 
      Height          =   285
      Left            =   7335
      TabIndex        =   12
      Top             =   4320
      Width           =   780
   End
   Begin VB.TextBox mxiter 
      Height          =   285
      Left            =   7335
      TabIndex        =   10
      Top             =   5040
      Width           =   780
   End
   Begin VB.ComboBox SetList 
      Height          =   315
      Left            =   5490
      TabIndex        =   8
      Text            =   "Combo1"
      Top             =   1980
      Width           =   1950
   End
   Begin VB.TextBox cyval 
      Height          =   330
      Left            =   6975
      TabIndex        =   7
      Top             =   3240
      Width           =   510
   End
   Begin VB.CommandButton Set 
      Caption         =   "Draw Set"
      Height          =   330
      Left            =   5670
      TabIndex        =   5
      Top             =   2385
      Width           =   1680
   End
   Begin VB.CommandButton julia 
      Caption         =   "Draw Julia"
      Height          =   300
      Left            =   6000
      TabIndex        =   3
      Top             =   3645
      Width           =   1530
   End
   Begin VB.TextBox cxval 
      Height          =   330
      Left            =   5985
      TabIndex        =   1
      Top             =   3240
      Width           =   510
   End
   Begin VB.PictureBox plane 
      BackColor       =   &H00FFFFFF&
      Height          =   4470
      Left            =   360
      ScaleHeight     =   4
      ScaleLeft       =   -2
      ScaleMode       =   0  'User
      ScaleTop        =   -2
      ScaleWidth      =   4
      TabIndex        =   0
      Top             =   405
      Width           =   4830
   End
   Begin VB.Label Label5 
      Caption         =   "Divergence Radius   ="
      Height          =   240
      Left            =   5535
      TabIndex        =   13
      Top             =   4725
      Width           =   1680
   End
   Begin VB.Label Label4 
      Caption         =   "Convergence Criteria ="
      Height          =   240
      Left            =   5535
      TabIndex        =   11
      Top             =   4365
      Width           =   1680
   End
   Begin VB.Label Label3 
      Caption         =   "Max iteration              ="
      Height          =   240
      Left            =   5535
      TabIndex        =   9
      Top             =   5085
      Width           =   1815
   End
   Begin VB.Label Label2 
      Caption         =   "cy ="
      Height          =   285
      Left            =   6615
      TabIndex        =   6
      Top             =   3285
      Width           =   330
   End
   Begin VB.Label progress 
      Height          =   225
      Left            =   1035
      TabIndex        =   4
      Top             =   5040
      Width           =   3525
   End
   Begin VB.Label Label1 
      Caption         =   "cx ="
      Height          =   285
      Left            =   5580
      TabIndex        =   2
      Top             =   3285
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cval_Change()
    c = Val(cval.Text)
End Sub

Private Sub clrpln_Click()
plane.Cls
End Sub

Private Sub cnverr_Change()
ConvergeErr = Val(cnverr.Text)
End Sub

Private Sub cxval_Change()
cx = Val(cxval.Text)
End Sub

Private Sub cyval_Change()
cy = Val(cyval.Text)
End Sub

Private Sub divrad_Change()
DivergeRad = Val(divrad.Text)
End Sub

Private Sub Form_Load()
    Call InitGlobals
    cxval.Text = Str(cx)
    cyval.Text = Str(cy)
    mxiter.Text = Str(maxIter)
    cnverr.Text = Str(ConvergeErr)
    divrad.Text = Str(DivergeRad)
    SetList.Text = "Mandelbrot"
    
    SetList.AddItem "Mandelbrot"
    SetList.AddItem "Mandelbar"
    SetList.AddItem "NR: z^3 = 1"
End Sub


Private Sub julia_Click()
    Dim a As Single, b As Single, bRef As Single
    Dim aStep As Single, bStep As Single, colr As Long
    Dim pt As point, ConvergeTo As point, iterno As Integer
    
    plane.Cls
    aStep = plane.ScaleWidth / 350
    bStep = plane.ScaleHeight / 350
    ConvergeNo = 0
    pointNo = 0
    
    For a = plane.ScaleLeft To (plane.ScaleWidth + plane.ScaleLeft) Step aStep
        For b = plane.ScaleTop To (plane.ScaleHeight + plane.ScaleTop) Step bStep
            pt.xc = a
            pt.yc = b
            bRef = 2 * plane.ScaleTop + plane.ScaleHeight - b
            If IsConverge(pt, ConvergeTo, iterno) = True Then
                colr = getInsideColor(pt, ConvergeTo, iterno)
                plane.PSet (a, bRef), colr
                ConvergeNo = ConvergeNo + 1
            Else
                colr = getOutsideColor(pt, ConvergeTo, iterno)
                plane.PSet (a, bRef), colr
            End If
            pointNo = (b / bStep) + (a / aStep) * 350
        Next b
    Next a
End Sub

Private Sub julia2_Click()
Dim a As Long, b As Integer, dum As Integer, toss As Single
Dim cycleNos As Integer, itrNo As Integer, startRad As Single
Dim rndTh As Single, rndRad As Single, itrPt As point, rootPt1 As point, rootPt2 As point

cycleNo = 10000
itrNo = 100
startRad = 2

For a = 1 To cycleNo
    rndTh = pi - 2 * pi * Rnd
    'Do
        'rndRad = startRad * Rnd
        'itrPt.xc = rndRad * Cos(rndTh)
        'itrPt.yc = rndRad * Sin(rndTh)
    'Loop Until plane.point(itrPt.xc, itrPt.yc) = plane.BackColor
    itrPt.xc = startRad * Cos(rndTh)
    itrPt.yc = startRad * Sin(rndTh)
    For b = 1 To itrNo
        If plane.point(itrPt.xc, itrPt.yc) = plane.BackColor Then
            plane.PSet (itrPt.xc, itrPt.yc), RGB(b * 255 / itrNo, 0, 0)
        End If
        itrPt.xc = itrPt.xc - cx
        itrPt.yc = itrPt.yc - cy
        dum = cplxSqrt(itrPt, rootPt1, rootPt2)
        If plane.point(rootPt1.xc, rootPt1.yc) = plane.BackColor And Not (plane.point(rootPt2.xc, rootPt2.yc) = plane.BackColor) Then
            itrPt = rootPt1
            GoTo nxtb
        ElseIf plane.point(rootPt2.xc, rootPt2.yc) = plane.BackColor And Not (plane.point(rootPt1.xc, rootPt1.yc) = plane.BackColor) Then
            itrPt = rootPt2
            GoTo nxtb
        End If
        toss = Rnd
        If toss < 0.5 Then
            itrPt = rootPt1
        Else
            itrPt = rootPt2
        End If
nxtb:
    Next b
Next a

End Sub

Private Sub mxiter_Change()
maxIter = Val(mxiter.Text)
End Sub

Private Sub plane_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    cx = X
    cy = Y
    cxval.Text = Str(cx)
    cyval.Text = Str(cy)
End Sub

Private Sub Set_Click()
    Dim a As Single, b As Single, bRef As Single
    Dim aStep As Single, bStep As Single, colr As Long
    Dim pt As point, ConvergeTo As point, iterno As Integer
    
    plane.Cls
    aStep = plane.ScaleWidth / 350
    bStep = plane.ScaleHeight / 350
    ConvergeNo = 0
    pointNo = 0
    
    For a = plane.ScaleLeft To (plane.ScaleWidth + plane.ScaleLeft) Step aStep
        For b = plane.ScaleTop To (plane.ScaleHeight + plane.ScaleTop) Step bStep
            pt.xc = a
            pt.yc = b
            cx = a
            cy = b
            bRef = 2 * plane.ScaleTop + plane.ScaleHeight - b
            If IsConverge(pt, ConvergeTo, iterno) = True Then
                colr = getInsideColor(pt, ConvergeTo, iterno)
                plane.PSet (a, bRef), colr
                ConvergeNo = ConvergeNo + 1
            Else
                colr = getOutsideColor(pt, ConvergeTo, iterno)
                plane.PSet (a, bRef), colr
            End If
            pointNo = (b / bStep) + (a / aStep) * 350
        Next b
    Next a
End Sub


Private Sub set2_Click()
Dim a As Long, b As Integer, dum As Integer, toss As Single
Dim cycleNos As Integer, itrNo As Integer, startRad As Single
Dim rndTh As Single, rndRad As Single, itrPt As point, initPt As point, rootPt1 As point, rootPt2 As point

cycleNo = 10000
itrNo = 100
startRad = 2

For a = 1 To cycleNo
    rndTh = pi - 2 * pi * Rnd
    'Do
        'rndRad = startRad * Rnd
        'itrPt.xc = rndRad * Cos(rndTh)
        'itrPt.yc = rndRad * Sin(rndTh)
    'Loop Until plane.point(itrPt.xc, itrPt.yc) = plane.BackColor
    itrPt.xc = startRad * Cos(rndTh)
    itrPt.yc = startRad * Sin(rndTh)
    initPt = itrPt
    For b = 1 To itrNo
        If plane.point(itrPt.xc, itrPt.yc) = plane.BackColor Then
            plane.PSet (itrPt.xc, itrPt.yc), RGB(b * 255 / itrNo, 0, 0)
        End If
        'itrPt.xc = itrPt.xc + 0.25
        'itrPt.yc = 4 * itrPt.yc
        itrPt.xc = itrPt.xc - initPt.xc
        itrPt.yc = itrPt.yc - initPt.yc
        dum = cplxSqrt(itrPt, rootPt1, rootPt2)
        'If plane.point(rootPt1.xc, rootPt1.yc) = plane.BackColor And Not (plane.point(rootPt2.xc, rootPt2.yc) = plane.BackColor) Then
            'itrPt = rootPt1
            'GoTo nxtb
        'ElseIf plane.point(rootPt2.xc, rootPt2.yc) = plane.BackColor And Not (plane.point(rootPt1.xc, rootPt1.yc) = plane.BackColor) Then
            'itrPt = rootPt2
            'GoTo nxtb
        'End If
        toss = Rnd
        If toss < 0.5 Then
            itrPt = rootPt1
        Else
            itrPt = rootPt2
        End If
        'itrPt.xc = itrPt.xc - 0.5
nxtb:
    Next b
Next a

End Sub


Private Sub SetList_Change()
SetType = SetList.Text
End Sub

Private Sub SetList_Click()
SetType = SetList.Text
End Sub
